com.jnape.palatable.lambda.functions.builtin.fn2

## Class Until<A>

- java.lang.Object
- - com.jnape.palatable.lambda.functions.builtin.fn2.Until<A>

- Type Parameters:
    `A` - the `IO` value type
  All Implemented Interfaces:
    Fn1<Fn1<? super A,? extends Boolean>,Fn1<IO<A>,IO<A>>>, Fn2<Fn1<? super A,? extends Boolean>,IO<A>,IO<A>>, Applicative<Fn1<IO<A>,IO<A>>,Fn1<Fn1<? super A,? extends Boolean>,?>>, Cartesian<Fn1<? super A,? extends Boolean>,Fn1<IO<A>,IO<A>>,Fn1<?,?>>, Cocartesian<Fn1<? super A,? extends Boolean>,Fn1<IO<A>,IO<A>>,Fn1<?,?>>, Contravariant<Fn1<? super A,? extends Boolean>,Profunctor<?,Fn1<IO<A>,IO<A>>,Fn1<?,?>>>, Functor<Fn1<IO<A>,IO<A>>,Fn1<Fn1<? super A,? extends Boolean>,?>>, Profunctor<Fn1<? super A,? extends Boolean>,Fn1<IO<A>,IO<A>>,Fn1<?,?>>, Monad<Fn1<IO<A>,IO<A>>,Fn1<Fn1<? super A,? extends Boolean>,?>>, MonadReader<Fn1<? super A,? extends Boolean>,Fn1<IO<A>,IO<A>>,Fn1<Fn1<? super A,? extends Boolean>,?>>, MonadRec<Fn1<IO<A>,IO<A>>,Fn1<Fn1<? super A,? extends Boolean>,?>>, MonadWriter<Fn1<? super A,? extends Boolean>,Fn1<IO<A>,IO<A>>,Fn1<Fn1<? super A,? extends Boolean>,?>>

      public final class Until<A>
      extends Object
      implements Fn2<Fn1<? super A,? extends Boolean>,IO<A>,IO<A>>

  Given a `predicate function` for a value of some type `A` and an `IO` that yields a value of type `A`, produce an `IO` that repeatedly executes the original `IO` until the predicate returns true when applied to the yielded value.

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `IO<A>` | `checkedApply(Fn1<? super A,? extends Boolean> pred, IO<A> io)`
    `static <A> Until<A>` | `until()`
    `static <A> Fn1<IO<A>,IO<A>>` | `until(Fn1<? super A,? extends Boolean> pred)`
    `static <A> IO<A>` | `until(Fn1<? super A,? extends Boolean> pred, IO<A> io)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn2

      `apply, apply, checkedApply, compose, contraMap, curried, curry, diMapL, discardR, flip, fn2, fromBiFunction, toBiFunction, uncurry, widen`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn1

      `andThen, carry, cartesian, censor, choose, cocartesian, diMap, diMapR, discardL, flatMap, fmap, fn1, fromFunction, lazyZip, listens, local, pure, pureFn1, thunk, toFunction, trampolineM, zip, zip`

    - ### Methods inherited from interface com.jnape.palatable.lambda.monad.Monad

      `join`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functor.Functor

      `coerce`

- - ### Method Detail

    - #### checkedApply

          public IO<A> checkedApply(Fn1<? super A,? extends Boolean> pred,
                                    IO<A> io)

      Specified by:
        `checkedApply` in interface `Fn2<Fn1<? super A,? extends Boolean>,IO<A>,IO<A>>`

    - #### until

          public static <A> Until<A> until()

    - #### until

          public static <A> Fn1<IO<A>,IO<A>> until(Fn1<? super A,? extends Boolean> pred)

    - #### until

          public static <A> IO<A> until(Fn1<? super A,? extends Boolean> pred,
                                        IO<A> io)